'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

var _clone = /*#__PURE__*/require('./../util/clone');

var _clone2 = /*#__PURE__*/_interopRequireDefault(_clone);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Sets the given property and value on the object. Returning a new object.
 * @signature associate :: String k -> {} -> v -> {k: v}
 * @func
 * @example
 * const obj = associate('c', { a: b }, d)  // { a: b, c: d }
 */
const associate = /*#__PURE__*/(0, _curry2.default)((prop, obj, val) => {
  const c = (0, _clone2.default)(obj);

  c[prop] = val;
  return c;
});

exports.default = associate;