'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

var _sum = /*#__PURE__*/require('./../sum');

var _sum2 = /*#__PURE__*/_interopRequireDefault(_sum);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Averages the given array values
 * @signature average :: [Number] -> Number
 * @func
 * @example
 * average([ 1, 2, 3 ]); // 2
 * average(1, 2, 3); // 2
 * average(); // 0
 */
const average = (...nums) => (0, _isArray2.default)(nums) && nums.length ? (0, _sum2.default)([...nums]) / [...nums].length : 0;

exports.default = average;