'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Takes a joiner func, and two other funcs and a value. The value is given to both funcs and the
 * results of each of these is given to the joiner func.
 * @signature Fork :: (b -> c -> d) -> (a -> b) -> (a -> c) -> a -> d
 * @func
 * @aka join
 */
const Fork = /*#__PURE__*/(0, _curry2.default)((joiner, fnA, fnB, x) => joiner(fnA(x), fnB(x)));

exports.default = Fork;