'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Given two functions that take the same value, returns the first if the result is truthy, otherwise, the second.
 * @signature OR :: (a -> b) -> (a -> b) -> b
 * @func
 * @aka alternation
 */
const OR = /*#__PURE__*/(0, _curry2.default)((f, g) => x => f(x) || g(x));

exports.default = OR;