'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Removes falsey values from an array.
 * @signature compact :: [a] -> [a]
 * @func
 * @example
 * compact([ 0, 1, false, 2, '', 3, 'a', 'e' * 23, NaN, 's', 34 ]); // [ 1, 2, 3, 'a', 's', 34 ]
 * compact(null) // []
 */
const compact = arr => (0, _isArray2.default)(arr) ? arr.filter(Boolean) : [];

exports.default = compact;