'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

var _isString = /*#__PURE__*/require('./../util/isString');

var _isString2 = /*#__PURE__*/_interopRequireDefault(_isString);

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Concatenates two String|Arrays together.
 * Returns empty array if value arent of the same type or not String|Array.
 * @signature concat :: a -> b -> c
 * @func
 * @example
 * concat('foo', 'bar') // foobar
 * concat([1, 2], [3, 4]) // [1, 2, 3, 4]
 */
const concat = /*#__PURE__*/(0, _curry2.default)((a, b) => (0, _isArray2.default)(a) && (0, _isArray2.default)(b) ? a.concat(b) : (0, _isString2.default)(a) && (0, _isString2.default)(b) ? `${a}${b}` : []);

exports.default = concat;