'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reduce = /*#__PURE__*/require('./../reduce');

var _reduce2 = /*#__PURE__*/_interopRequireDefault(_reduce);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Concatenates N Arrays together.
 * @signature concat :: [a] -> [b] -> ...[n] -> [m]
 * @func
 * @example
 * concatN([1, 2], [3, 4], [5, 6]) // [1, 2, 3, 4, 5, 6]
 */
const concatN = (...args) => (0, _reduce2.default)([], (acc, val) => [...acc, ...val], args);

exports.default = concatN;