'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

var _isFunction = /*#__PURE__*/require('./../util/isFunction');

var _isFunction2 = /*#__PURE__*/_interopRequireDefault(_isFunction);

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Determines if all element in an array satisfy the given test function
 * @signature every :: (a -> Bool) -> [a] -> Bool
 * @func
 * @aka all
 * @example
 * every(Boolean, [1, 2, 3, 4]) // true
 * every(Boolean, [1, 2, null, 4]) // false
 */
const every = /*#__PURE__*/(0, _curry2.default)((fn, arr) => (0, _isArray2.default)(arr) && (0, _isFunction2.default)(fn) ? arr.every(fn) : false);

exports.default = every;