'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

var _clone = /*#__PURE__*/require('./../util/clone');

var _clone2 = /*#__PURE__*/_interopRequireDefault(_clone);

var _isFunction = /*#__PURE__*/require('./../util/isFunction');

var _isFunction2 = /*#__PURE__*/_interopRequireDefault(_isFunction);

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Filters the array using the given function.
 * @signature filter :: (a -> Boolean) -> [a] -> [a]
 * @func
 * @example
 * filter(x => x > 5, [1, 2, 3, 5, 6, 7]) // [6, 7]
 */
const filter = /*#__PURE__*/(0, _curry2.default)((func, arr) => !(0, _isFunction2.default)(func) ? (0, _isArray2.default)(arr) ? (0, _clone2.default)(arr) : [] : (0, _isArray2.default)(arr) ? arr.filter(func) : []);

exports.default = filter;