'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Finds the first element that satisfies the given test func.
 * @signature find :: (a -> Boolean) -> [a] -> a
 * @func
 * @example
 * find(x => x.score === 5, [{score: 1}, {score: 2}, {score: 5}, {score: 6}, {score: 7}]) // {score: 5}
 */
const find = /*#__PURE__*/(0, _curry2.default)((fn, x) => x.find(fn));

exports.default = find;