'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _clone = /*#__PURE__*/require('./../util/clone');

var _clone2 = /*#__PURE__*/_interopRequireDefault(_clone);

var _distinct = /*#__PURE__*/require('./../distinct');

var _distinct2 = /*#__PURE__*/_interopRequireDefault(_distinct);

var _filter = /*#__PURE__*/require('./../filter');

var _filter2 = /*#__PURE__*/_interopRequireDefault(_filter);

var _groupBy = /*#__PURE__*/require('./../groupBy');

var _groupBy2 = /*#__PURE__*/_interopRequireDefault(_groupBy);

var _map = /*#__PURE__*/require('./../map');

var _map2 = /*#__PURE__*/_interopRequireDefault(_map);

var _select = /*#__PURE__*/require('./../select');

var _select2 = /*#__PURE__*/_interopRequireDefault(_select);

var _sort = /*#__PURE__*/require('./../sort');

var _sort2 = /*#__PURE__*/_interopRequireDefault(_sort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = arr => {
  let _array = arr || [];

  return {
    where(func) {
      _array = (0, _filter2.default)(func, _array);
      return this;
    },

    orderBy(func) {
      _array = (0, _sort2.default)(_array, func);
      return this;
    },

    groupBy(func) {
      return (0, _groupBy2.default)(func, _array);
    },

    distinct(func) {
      _array = (0, _distinct2.default)(_array, func);
      return this;
    },

    select(props) {
      _array = (0, _map2.default)(item => (0, _select2.default)(item, props), _array);
      return this;
    },

    value() {
      return (0, _clone2.default)(_array);
    }
  };
};