'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = /*#__PURE__*/require('./../curry');

var _curry2 = /*#__PURE__*/_interopRequireDefault(_curry);

var _isFunction = /*#__PURE__*/require('./../util/isFunction');

var _isFunction2 = /*#__PURE__*/_interopRequireDefault(_isFunction);

var _isArray = /*#__PURE__*/require('./../util/isArray');

var _isArray2 = /*#__PURE__*/_interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Groups the elements of an array based on the given function.
//
// groupBy(Math.floor, [ 6.1, 4.2, 6.3 ]);
// >> { '4': [4.2], '6': [ 6.1, 6.3 ] }
//
// groupBy('length', [ 'one', 'two', 'three' ]);
// >> { '3': [ 'one', 'two' ], '5': ['three'] }
//
// groupBy(null, ['one', 'two', 'three']);
// >> {}
//
// groupBy(Math.floor, null);
// >> {}
//
exports.default = /*#__PURE__*/(0, _curry2.default)((func, arr) => func != null && (0, _isArray2.default)(arr) ? arr.map((0, _isFunction2.default)(func) ? func : val => val[func]).reduce((acc, val, i) => {
  acc[val] = (acc[val] || []).concat(arr[i]);
  return acc;
}, {}) : {});