'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isFunction = /*#__PURE__*/require('./../../util/isFunction');

var _isFunction2 = /*#__PURE__*/_interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class IO {
  constructor(effect) {
    if (!(0, _isFunction2.default)(effect)) {
      throw new Error('effect needs to be a function');
    }

    this._effect = effect;
  }

  static of(val) {
    return new IO(() => val);
  }

  static from(fn) {
    return new IO(fn);
  }

  map(fn) {
    return new IO(() => fn(this._effect()));
  }

  chain(fn) {
    return fn(this._effect());
  }

  run() {
    return this._effect();
  }
}

exports.default = IO;