'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _clone = /*#__PURE__*/require('./../util/clone');

var _clone2 = /*#__PURE__*/_interopRequireDefault(_clone);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Randomizes the order of the values of an array, returning a new array.
// Uses the Fisher-Yates algoritm to reorder the elements of the array.
//
// shuffle([ 1, 2, 3 ]);
// >> [ 2, 3, 1 ]
//
exports.default = ([...arr]) => {
  const carr = (0, _clone2.default)(arr);
  let m = carr.length;

  while (m) {
    const i = Math.floor(Math.random() * m--);

    [carr[m], carr[i]] = [carr[i], carr[m]];
  }

  return carr;
};