import curry from './../curry';

// Returns the standard deviation of an array of numbers.
//
// deviation([ 10, 2, 38, 23, 38, 23, 21 ]);
// >> 13.284434142114991 (sample)
//
// deviation([ 10, 2, 38, 23, 38, 23, 21 ], true);
// >> 12.29899614287479 (population)
//
var deviation = /*#__PURE__*/curry(function (usePopulation, arr) {
  var mean = arr.reduce(function (acc, val) {
    return acc + val;
  }, 0) / arr.length;

  return Math.sqrt(arr.reduce(function (acc, val) {
    return acc.concat(Math.pow(val - mean, 2));
  }, []).reduce(function (acc, val) {
    return acc + val;
  }, 0) / (arr.length - (usePopulation ? 0 : 1)));
});

export default deviation;