import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Set from 'babel-runtime/core-js/set';
import curry from './../curry';
import isArray from './../util/isArray';

/**
 * Returns the difference between two arrays.
 * @signature difference :: [a] -> [b] -> [c]
 * @func
 * @example
 * difference([ 1, 2, 3 ], [ 1, 2, 4 ]) // [3]
 * difference([], [ 1, 2, 4 ]) // [ 1, 2, 4 ]
 * difference([ 1, 2, 3 ], []) // [ 1, 2, 3 ]
 * difference([ 1, 2, 3 ], null) // [ 1, 2, 3 ]
 */
var difference = /*#__PURE__*/curry(function (a, b) {
  var s = isArray(b) && b.length ? new _Set(b) : new _Set();

  return isArray(a) && a.length ? a.filter(function (x) {
    return !s.has(x);
  }) : [].concat(_toConsumableArray(s));
});

export default difference;