import _Set from 'babel-runtime/core-js/set';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import isArray from './../util/isArray';

/**
 * Returns all of the distinct values of an array.
 * @signature distinct :: [a] -> [b]
 * @func
 * @example
 * distinct([ 1, 2, 2, 3, 4, 4, 5 ]) // [ 1, 2, 3, 4, 5 ]
 */
var distinct = function distinct(arr) {
  return isArray(arr) ? [].concat(_toConsumableArray(new _Set(arr))) : [];
};

export default distinct;