import curry from './../curry';

/**
 * Finds the first element that satisfies the given test func.
 * @signature find :: (a -> Boolean) -> [a] -> a
 * @func
 * @example
 * find(x => x.score === 5, [{score: 1}, {score: 2}, {score: 5}, {score: 6}, {score: 7}]) // {score: 5}
 */
var find = /*#__PURE__*/curry(function (fn, x) {
  return x.find(fn);
});

export default find;