import clone from './../util/clone';
import _distinct from './../distinct';
import filter from './../filter';
import _groupBy from './../groupBy';
import map from './../map';
import _select from './../select';
import sort from './../sort';

export default (function (arr) {
  var _array = arr || [];

  return {
    where: function where(func) {
      _array = filter(func, _array);
      return this;
    },
    orderBy: function orderBy(func) {
      _array = sort(_array, func);
      return this;
    },
    groupBy: function groupBy(func) {
      return _groupBy(func, _array);
    },
    distinct: function distinct(func) {
      _array = _distinct(_array, func);
      return this;
    },
    select: function select(props) {
      _array = map(function (item) {
        return _select(item, props);
      }, _array);
      return this;
    },
    value: function value() {
      return clone(_array);
    }
  };
});