import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Set from 'babel-runtime/core-js/set';
import curry from './../curry';
import isArray from './../util/isArray';

// Returns a list of elements that exist in both arrays.
//
// intersection([ 1, 2, 3 ], [ 4, 3, 2 ]);
// >> [ 2,3 ]
//
export default /*#__PURE__*/curry(function (a, b) {
  var s = isArray(b) ? new _Set(b) : new _Set();

  return isArray(a) ? a.filter(function (x) {
    return s.has(x);
  }) : [].concat(_toConsumableArray(s));
});