// Performs left-to-right function composition.
// The first (leftmost) function can accept one or more arguments; the remaining functions must be unary.
//
// const add5 = x => x + 5;
// const multiply = (x, y) => x * y;
// const multiplyAndAdd5 = pipe(multiply, add5);
// multiplyAndAdd5(5, 2);
//
// >> 15
//
export default (function () {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return fns.reduce(function (f, g) {
    return function () {
      return g(f.apply(undefined, arguments));
    };
  });
});