import _Promise from "babel-runtime/core-js/promise";
// Converts an asynchronous function to return a promise.
// Use currying to return a function returning a Promise that calls the original function.
// Use the ...rest operator to pass in all the parameters.
//
// const delay = promisify((d, cb) => setTimeout(cb, d));
// delay(2000).then(() => console.log('Hi!'));
//
export default (function (func) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new _Promise(function (resolve, reject) {
      return func.apply(undefined, args.concat([function (err, result) {
        return err ? reject(err) : resolve(result);
      }]));
    });
  };
});