import _toArray from 'babel-runtime/helpers/toArray';
import clone from './../util/clone';

// Randomizes the order of the values of an array, returning a new array.
// Uses the Fisher-Yates algoritm to reorder the elements of the array.
//
// shuffle([ 1, 2, 3 ]);
// >> [ 2, 3, 1 ]
//
export default (function (_ref) {
  var _ref2 = _toArray(_ref),
      arr = _ref2.slice(0);

  var carr = clone(arr);
  var m = carr.length;

  while (m) {
    var i = Math.floor(Math.random() * m--);

    var _ref3 = [carr[i], carr[m]];
    carr[m] = _ref3[0];
    carr[i] = _ref3[1];
  }

  return carr;
});