import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Set from 'babel-runtime/core-js/set';
import curry from './../curry';
import isArray from './../util/isArray';

// Returns the symmetric difference between two arrays.
//
// symmetricDifference([ 1, 2, 3 ], [ 1, 2, 4 ]);
// >> [ 3, 4 ]
//
export default /*#__PURE__*/curry(function (a, b) {
  var sA = isArray(a) ? new _Set(a) : new _Set();
  var sB = isArray(b) ? new _Set(b) : new _Set();

  return [].concat(_toConsumableArray(a.filter(function (x) {
    return !sB.has(x);
  })), _toConsumableArray(b.filter(function (x) {
    return !sA.has(x);
  })));
});